/* EVB-2478: cmd.c */
/* Hintergrund-Kommandointerpreter fr Kommunikation ber UART */

/*
Das ist erstmal ein Sammelsurium diverser Testkommandos und weit davon entfernt,
sowas wie COMMAND.COM zu sein. Dazu kommt mit Chan's FF und langen Dateinamen
noch das Herumwurschteln zwischen char und TCHAR...
*/

#include "LPC24xx.h"
#include "StdTypes.h"
#include "cmd.h"
#include "conv.h"
#include "gdi.h"
#include "startup.h"
#include "gio.h"
#include "sdio.h"
#include "ff.h"
#include "efsys.h"
#include "usb.h"


const char testtext[] =
{"0123456789 >>> Als Bauer Christoph Duewels-Eck Fuenf Gulden Hatte Im Jacket, Kam Leider Mit Ner Ollen Pistol Quinquilius Raeuberrabenseck, Stahl Taler Und Verschiednes Weg, X Y Z     +++" };


/************* externen RAM testen ****************/
extern void DoDisplay (word wo);

void TestXTest (word wo)
{ const char* Q;
  char* Z;
  dword L;
  long  i;

  Q = testtext;
  Z = (char*) 0xA0000000;
  L = 0xFFFFF0;              // 16 Meg - 16
  i = 0;
  String_Out("Teste mit Text", wo);
  TxDone(wo);
  while (L)
  {  *Z++ = *Q++;
     if (*Q==0)
     { Q = testtext;
       --i;
       if(i<0)
       { i = 1000;
         Char_Out('.', wo);
       }
     }
     --L;
  }

  String_Out("\r\n...so, mal sehen.\r\n", wo);
  von = (char*) 0xA0000000;
  bis = (char*) 0xA00001FF;
  DoDisplay(wo);
}

void TestXRAM (word wo)
{ volatile dword* PDW;
  long   i, j;
  volatile dword  D;

  String_Out("Teste SDRAM\r\n", wo);
  TxDone(wo);
  i = 32000;
  j = 0;
  D = 0x43424100;                // 00  'A' 'B' 'C'
  PDW = (dword*)0xA0000000;
  while ((dword)PDW <= 0xA0FFFFFF)
  { *PDW = D;
     D = D + 0x01010101;
     ++PDW;
     ++j;
     if (j>=17)
     { j = 0;
       D = 0x43424100;
     }
     --i;
     if(!i)
     { i = 32000;
       Char_Out('.', wo);
     }
  }

  String_Out("\r\n+", wo);
  PDW = (dword*)0xA0000000;
  D = 0x43424100;
  i = 32000;
  while ((dword)PDW <= 0xA0FFFFFF)
  { if (*PDW != D) break;
    D = D + 0x01010101;
    ++PDW;
    ++j;
    if (j>=17)
    { j = 0;
      D = 0x43424100;
    }
    --i;
    if(!i)
    { i = 32000;
      Char_Out('+', wo);
    }
  }
  D = (dword)PDW - 0xA0000000;
  ExtRamSize = D;
  String_Out("\r\nSDRAM Size ", wo);
  Dezi_Out (ExtRamSize, 1, wo);
  CRLF_Out(wo);

}

/* externen RAM fllen */
void FillXRAM (word wo)
{ char*  P;
  word*  W;
  dword* D;
  dword  x;

  P = (char*)ExtRamBegin;
  W = (word*)ExtRamBegin;
  D = (dword*)ExtRamBegin;

  x = Hex_In(&Cpt);

  if (x>0xFFFF)
  { while ((dword)D < 0xA1000000) *D++ = x;
    return;
  }

  if (x>0xFF)
  { while ((dword)W < 0xA1000000) *W++ = x;
    return;
  }
  while ((dword)P < 0xA1000000) *P++ = x;
}


/* Gertestatus ausgeben */
void DoStatus(word wo)
{ dword D;
  String_Out("Gertestatus ", wo);
  String_Out((char*)Manifest, wo);
  String_Out("\r\nSDRAM $", wo);
  HexL_Out ((dword) ExtRamBegin, wo);
  String_Out(" .. $", wo);
  HexL_Out ((dword) ExtRamBegin + (dword) ExtRamSize - 1, wo);
  String_Out(" = ", wo);
  Dezi_Out ((dword) ExtRamSize/1048576, 1, wo);
  String_Out(" MB\r\n", wo);
  if(SD_CardDetected)
  { D = SD_CardSize/1024;
    Dezi_Out (D, 1, wo);
    String_Out("K\r\n", wo);
  }
  else String_Out("no SD\r\n", wo);
}


/* Display Memory
 D  anf count    display Bereich
 DR anf count    display RAM     (0x40000000 ...)
 DX anf count    display Memory2 (0x82000000 ...)
*/

void DoDisplay (word wo)
{ char* ivon;
  char* ibis;
  char* von2;
  dword L;
  word  i;
  char  c;

  L = 255;
  if (*Cpt)
  { if (match("R",&Cpt))
    { L = Hex_In(&Cpt);
      von = (char*)( L + 0x40000000);
      L = Hex_In(&Cpt);
      if (!L) L = 255;
      bis = von + L;
    }
    else
    if (match("X",&Cpt))
    { L = Hex_In(&Cpt);
      von = (char*) (L + 0xA0000000);
      L = Hex_In(&Cpt);
      if (!L) L = 255;
      bis = von + L;
    }
    else
    { von = (char*) Hex_In(&Cpt);
      L = Hex_In(&Cpt);
      if (!L) L = 255;
      bis = von + L;
    }
  }

  ivon = (char*) von;
  ibis = (char*) bis;

  while((long) ibis >= (long) ivon)
  {  CRLF_Out(wo);
     HexL_Out((long) ivon, wo);
     von2 = ivon;
     Char_Out(':', wo);
     i = 16;
     while(i)
     { --i;
       Char_Out(' ', wo);
       HexB_Out(*ivon++, wo);
     }
     Char_Out(' ', wo);
     i = 16;
     while(i)
     { --i;
       c = *von2++;
       if ((c<' ')||(c>126)) c = ' ';
       Char_Out(c, wo);
     }
  }
  von = (char*) ivon;
  bis = (char*) ivon + L;
  CRLF_Out(wo);
}

word TeePuffer[140];
extern byte buf[512];
word lfn[_MAX_LFN + 1];


void WStrOut(TCHAR* aname, word wo)
{ word w;
  char c;

  while (*aname)
  { w = *aname++;
    c = w & 255;
    if (w>255) c = '$';
    Char_Out(c,wo);
  }
}

bool GetFileName (TCHAR* Buffer, int maxBufLen)
{ int  i;
  bool qdbl;
  char c;

  i = 0;
  Buffer[i] = 0;
  IgnoreSpace(&Cpt);
  qdbl = false;
  while (i<maxBufLen)
  { c = *Cpt;
    if (!c)
    { if (qdbl) return false;
      return true;
    }
    if (c=='"')
    { if (qdbl)
      { ++Cpt;
        return true;
      }
      qdbl = true;
    }
    else
    { if (qdbl)
      { if (c < ' ') return false;
        Buffer[i] = c;
      }
      else
      { if (c <= ' ') return true;
        Buffer[i] = c;
      }
      ++i;
    }

    Buffer[i] = 0;
    ++Cpt;
  }
  return false;
}


void DoReadTest(word wo)
{ dword D;
  long L;
  bool b;

  TRSTATUS = 0;
  D = T0TC+1000;
  L = 0;
  while(D>T0TC)
  { b = SD_ReadBlock (L, (dword*) &buf);
      if (!b)
      { String_Out("err ", wo);
        HexL_Out(TRSTATUS, wo);
        CRLF_Out(wo);
        return;
      }
      ++L;
  }
  String_Out("\r\nSpeed ", wo);
  Dezi_Out(L/2,1,wo);
  String_Out(" K Bytes/s\r\n", wo);
}

void DoReadBlock (word wo)
{ long L, j, k;
  bool b;
  char c;

  L = 512;
  while (L) { buf[--L] = 0xFF; }
  L = Long_In(&Cpt);
  b = SD_ReadBlock (L, (dword*) &buf);
  if (!b)
    { String_Out("err ", wo);
      HexL_Out(TRSTATUS, wo);
      CRLF_Out(wo);
      return;
    }
  CRLF_Out(wo);
  j = 0;
  while (j<512)
    { k = 0;
      HexW_Out(j,wo);
      String_Out(": ", wo);
      while (k<16)
      { c = buf[j+k];
        HexB_Out(c,wo);
        Char_Out(' ', wo);
        ++k;
      }
      k = 0;
      while (k<16)
      { c = buf[j+k];
        if ((c<' ')||(c>250)) c = ' ';
        Char_Out(c,wo);
        ++k;
      }
      CRLF_Out(wo);
      j = j + 16;
    }
}




bool DoChdir (word wo)
{ TCHAR S[80];

  if (!GetFileName(S, sizeof(S))) return false;
  f_chdir(S);
  f_getcwd(S,sizeof(S));
  WStrOut(S, wo);
  String_Out(" >", wo);
  return true;
}



void DoDir (word wo)
{ FRESULT rc;     /* Result code */
  DIR dir;        /* Directory object */
  FILINFO fno;	  /* File information object */
  char S[6];

 fno.lfname = lfn;
 fno.lfsize = sizeof(lfn);

 String_Out("\r\nDirectory listing...\r\n", wo);
 rc = f_opendir(&dir, L"");
 if (rc)
 { String_Out(" no dir\r\n", wo);
   return;
 }
  _dirloop:
    rc = f_readdir(&dir, &fno);	       /* Read a directory item */
    if (rc || !fno.fname[0])
    { String_Out(" ..ende\r\n", wo);   /* Error or end of dir */
      return;
    }
    if (fno.fattrib & AM_DIR)
    { String_Out("   <dir>     ", wo);
    }
    else
    { Dezi_Out(fno.fsize,8,wo);
      S[0] = S[1] = S[2] = S[3] = '-'; S[4] = ' '; S[5] = 0;
      if (fno.fattrib & AM_RDO) S[0] = 'r';
      if (fno.fattrib & AM_ARC) S[1] = 'a';
      if (fno.fattrib & AM_HID) S[2] = 'h';
      if (fno.fattrib & AM_SYS) S[3] = 's';
      String_Out(S, wo);
    }
    if (*fno.lfname) WStrOut(fno.lfname, wo);
    else             WStrOut(fno.fname, wo);
    CRLF_Out(wo);

  goto _dirloop;
}


void DoList (word wo)
{ FRESULT rc;     /* Result code */
  FIL fsrc;
  TCHAR S[80];
  byte buffer[256];
  bool eof, crseen;
  long i, j;
  UINT br;
  char c;

  if (!GetFileName(S, sizeof(S))) return;
  rc = f_open(&fsrc, S, FA_OPEN_EXISTING | FA_READ);
  if (rc)
  { String_Out("kann ", wo);
    WStrOut(S, wo);
    String_Out(" nicht ffnen\r\n", wo);
    return;
  }
  String_Out("Datei ", wo);
  WStrOut(S, wo);
  CRLF_Out(wo);

  eof = false;

  j = 0;
  crseen = false;
  TRSTATUS = 0;
  while (!eof)
  { rc = f_read(&fsrc, buffer, sizeof(buffer), &br);     /* Read a chunk of src file */
    if (rc || br == 0) eof = true; /* error or eof */
    i = 0;

    while (i<br)
    { c = buffer[i++];
      if (c==13)
      { crseen = true;
        CRLF_Out(wo);
	j = 0;
	c = 0;
      }
      if (c==10)
      { if (!crseen)
        { CRLF_Out(wo);
	  j = 0;
 	  c = 0;
	}
        else
	{ Char_Out(13, wo);
          crseen = false;
	}
      }

      if (c)
      { Char_Out(c, wo);
        ++j;
      }
      if (j>85)
      { j = 0;
        CRLF_Out(wo);
      }
    }
  }
}


void DoCopy (word wo)
{ FRESULT rc;     /* Result code */
  FIL fsrc, fdst;
  TCHAR QFN[80];
  TCHAR DFN[80];
  UINT  br, bw;
  dword r, w;
  byte buffer[512];
  bool eof;

  if (!GetFileName(QFN, sizeof(QFN))) return;
  String_Out("Kopiere ", wo);
  WStrOut(QFN, wo);

  if (!GetFileName(DFN, sizeof(DFN))) return;
  String_Out(" nach ", wo);
  WStrOut(DFN, wo);
  CRLF_Out(wo);

  if (SD_readonly)
  { String_Out(" ..hey, SD ist r/o !\r\n", wo);
    return;
  }

  TRSTATUS = 0;
  rc = f_open(&fsrc, QFN, FA_OPEN_EXISTING | FA_READ);
  if (rc)
  { String_Out(" kann ", wo);
    WStrOut(QFN, wo);
    String_Out(" nicht ffnen\r\n", wo);
    return;
  }

  rc = f_open(&fdst, DFN, FA_CREATE_ALWAYS | FA_WRITE);
  if (rc)
  { String_Out(" kann ", wo);
    WStrOut(DFN, wo);
    String_Out(" nicht anlegen\r\n", wo);
    return;
  }

  eof = false;
  r = w = 0;
  while (!eof)
  { rc = f_read(&fsrc, buffer, sizeof(buffer), &br);  /* Read a chunk of src file */
    if ((rc)||(br == 0)) eof = true;                  /* error or eof */
    r += br;

    rc = f_write(&fdst, buffer, br, &bw);             /* Write it to the dst file */
    if ((rc)||(bw < br)) eof = true;                  /* error or disk full */
    w += bw;
  }
  f_close(&fsrc);
  f_close(&fdst);
  if (bw != br)
  { String_Out(" Fehler beim Kopieren.\r\ngelesen: ", wo);
    Dezi_Out(r,1,wo);
    String_Out(" geschrieben ", wo);
    Dezi_Out(w,1,wo);
    String_Out("  Disk voll?\r\n", wo);
  }
}

void DoDelete (word wo)
{ FRESULT rc;     /* Result code */
  TCHAR Name[80];

  if (!GetFileName(Name, sizeof(Name)))
  { WStrOut(Name, wo);
    String_Out(" wiebitte?", wo);
    return;
  }
  String_Out("lsche ", wo);
  WStrOut(Name, wo);
  CRLF_Out(wo);

  rc = f_unlink(Name);
  if (rc==FR_OK) return;

  /* Fehler gewesen */
  String_Out(TranslateErrorcode(rc), wo);
  CRLF_Out(wo);
}

/*
#define USBClkSt        (*(volatile unsigned long *)(0xFFE0CFF8))
#define USBIntSt        (*(volatile unsigned long *)(0xE01FC1C0))
#define USBDevIntSt     (*(volatile unsigned long *)(0xFFE0C200))
#define USBEpIntSt      (*(volatile unsigned long *)(0xFFE0C230))
#define USBEpIntSet     (*(volatile unsigned long *)(0xFFE0C23C))
*/

void DoSageUhrzeit (word wo)
{ long L, H, M, S;

  L = T0TC / 1000;
  S = L % 60;  L = L / 60;
  M = L % 60;  L = L / 60;
  H = L % 24;
  Dezi_Out(H,1,wo); Char_Out(':', wo);
  Dezi_Out(M,1,wo); Char_Out(':', wo);
  Dezi_Out(S,1,wo); Char_Out(':', wo);
  CRLF_Out(wo);
}

void DoUhrzeit (word wo)
{ long L, H, M, S;
  H = Long_In(&Cpt);
  M = Long_In(&Cpt);
  S = Long_In(&Cpt);
  L = 1000 * (((H*60)+M)*60 + S);
  T0TC = L;
  T0MR0 = L + 10;
}

void DoCommand (char* Pzeile, word wo)
{ Cpt = Pzeile;
  long L;
  char c;

  if (match("CD",&Cpt))    { if (!DoChdir(wo)) goto CommandError; return; }
  if (match("DIR",&Cpt))   { DoDir(wo); return;}
  if (match("LIST",&Cpt))  { DoList(wo); return;}
  if (match("COPY",&Cpt))  { DoCopy(wo); return;}
  if (match("DEL",&Cpt))   { DoDelete(wo); return;}


  if (match("D",&Cpt))     { DoDisplay(wo); return;}
  if (match("G?",&Cpt))    { DoStatus(wo);  return;}
  if (match("TT",&Cpt))    { TestXTest(wo);  return;}
  if (match("T",&Cpt))     { TestXRAM(wo);  return;}
  if (match("F",&Cpt))     { FillXRAM(wo);  return;}

  if (match("C",&Cpt))
  { L = (Long_In(&Cpt) & 3) << 2;
    PCLKSEL0 = (PCLKSEL0 & (~(3<<2))) | L;
    return;
  }

  if (match("RT",&Cpt))    { DoReadTest(wo); return;}
  if (match("R",&Cpt))     { DoReadBlock(wo); return;}

  if (match("U?",&Cpt))    { DoSageUhrzeit(wo); return;}
  if (match("U=",&Cpt))    { DoUhrzeit(wo); return;}
  if (match("UV",&Cpt))    { T0PR  = Long_In(&Cpt); return;}


  /* Platz fr weitere Kommandos */



  CommandError:
  if (!*Cpt) return;
  String_Out("wat? ", wo);
  while (*Cpt)
  { c = *Cpt;
    if (c < ' ')
    { Char_Out('^',wo);
      c = c + 0x40;
    }
    Char_Out(c, wo);
    ++Cpt;
  }
  CRLF_Out(wo);
}




/*************************************************************************/

void InitCmd (word wo)
{  long L;

   L = sizeof(Kommandozeile);
   while (L) Kommandozeile[--L] = 0;
   kzi = L;
   Char_Out('>', wo);
}

  /* Kommandozeile hereinholen */
void Talk (word wo)
{ char c;

  if (RxAvail(wo))
  { c =  GetChar(wo);
    if (c==10) return;
    if (c==13)
    { CRLF_Out(wo);
      DoCommand (Kommandozeile, wo);
      InitCmd(wo);
    }
    else
    { if (kzi>=(sizeof(Kommandozeile)-1)) return;
      if (c==8)
      { Char_Out(8, wo);
        Char_Out(' ', wo);
        Char_Out(8, wo);
        Kommandozeile[--kzi]=0;
      }
      else
      { if (c<' ')
        { Char_Out('^', wo);
          Char_Out(c+0x40, wo);
          Kommandozeile[kzi++] = c;
          Kommandozeile[kzi] = 0;
	  return;
        }
        Char_Out(c, wo);
        Kommandozeile[kzi++] = c;
        Kommandozeile[kzi] = 0;
      }
    }
  }
}


