/*****************************************************************************
 embedded Filesystem
 *****************************************************************************/

#ifndef __EFSYS_H__
#define __EFSYS_H__

// von Chan's FF
extern FATFS    Fatfs;        // File system object

// interne Datenstruktur zum Arbeiten mit einer Partition
#define TPARTREC  struct TPartitionRecord
struct TPartitionRecord
{ byte  Magic;         // Typecode dieser Partition oder 0 fr unbelegt
  bool  ReadOnly;      // Schieber an der SD-Karte
  char  DriveLetter;   // zugewiesener Laufwerksbuchstabe
  bool  Changed;       // ob Zurckschreiben erforderlich ist
  dword LBA_Start;     // Nr. des Anfangssektors der Partition
  dword LBA_NumSec;    // Gre der Partition
  FATFS* Fatfs;        // File system object
};


// wir halten erstmal 4 mgliche Partitionen vor:
extern TPARTREC  PartRec [4];


extern bool  InitPartitionRecord (void);


extern word  GetWord  (byte* buf, int aIndex);    // lesen eines 16 Bit Wortes auf krummen Adressen
extern dword GetDWord (byte* buf, int aIndex);    // lesen eines 32 Bit Wortes auf krummen Adressen
extern char* TranslateErrorcode(FRESULT code);

#endif

